SystemOrganization addCategory: #'Seaside-WebSocket-Examples'!

WARequestHandler subclass: #WAWebSocketExampleBroadcaster
	instanceVariableNames: 'sockets mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-WebSocket-Examples'!

!WAWebSocketExampleBroadcaster methodsFor: 'handling' stamp: 'pmm 8/1/2010 13:46'!
handleFiltered: aRequestContext
	| webSocket |
	webSocket := aRequestContext newWebSocket.
	
	"We don't need to #fork here, in fact we shouldn't since it ensures
	that shutting down WebServer shuts down any WebSockets, too."
	webSocket run! !

!WAWebSocketExampleBroadcaster methodsFor: 'initialization' stamp: 'pmm 8/1/2010 13:44'!
initialize
	super initialize.
	sockets := OrderedCollection new.
	mutex := WAMutex new! !
